package com.lovecoding.day13.finally01;

import org.junit.Test;

public class Test02 {

    @Test
    public void fun1(){
        System.out.println(fun2());
        //return 先执行  finally后执行
        //栈 = 栈帧 （ 局部变量表  操作数栈  返回值 动态链接   ）
        // return 先执行 往返回值 写入 11；
        // finally后执行  变量 a = 13：
        // 把返回值 之前写入的值 返回给调用者  == 11 不是 13；

    }

    private int fun2() {
        int a = 10;
        try {
            //int i = 1 / 0;
            a = 11;
            System.out.println("执行返回");
            return a;
        }catch (Exception e){
            a = 12;
            //return a;
        }finally {
            a = 13;
            System.out.println("执行finally");
            //return a;
        }
        return -1;
    }

}
